<?php
/**
 * ApiException
 * PHP version 5
 *
 * @category Class
 * @package  Drupal\tmgmt_apostrophgroup_provider\Restclient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Apostroph Group Rest API
 *
 * <h2>Einleitung </h2> <p>Das folgende Dokument beschreibt die REST Service Schnittstelle für myApostroph und einem externen Partner oder Kunden. Nachfolgend werden allgemeine Informationen zur Service beschrieben und dann die konkrete technische Implementierung.</p> <hr> <h2> Allgemeines </h2> <p>Dieser Service dient dazu, dass ein externer Partner oder Kunde von Apostroph Aufträge direkt via „Internet“ im ERP System Apos erstellen und bei Fertigstellung des Auftrages diesen auch abholen kann. Die Realisierung ist mittels ein REST Services realisiert. </p> <hr> <h2> Wissenswertes </h2>  <li> In der aktuellen Version kann nur eine Übersetzung erstellt werden. Bspw. von „de“ nach „en“, aber nicht von „de“ nach „en“ und von „de“ nach „fr“.</li> <li>Zusätzlich zu den Auftragsinformationen können 2 Dateien übermittelt werden.  <ul><li>Datei mit Endung xliff (kann erweitert werden)</li> <li>Datei mit Endung tmx</li></ul> Beide Dateien müssen im Zip Format übertragen/geliefert werden</li> <li>Die Initialisierung des Services passiert immer von Seite „externer Partner“. Dieser Service des Partners liefert Daten und holt auch wieder Daten ab</li> <li>Pro Auftrag muss immer eine Apos Kundennummer mitgegeben werden, so kann der Auftrag dem korrekten Kunden zugeordnet werden. Diese Nummern müssen auf Seite externer Partner bekannt sein </li> <hr> <h2> Service Beschreibung </h2> <p><u>Servicetyp</u>: REST</p> <p> <u>Serialisierung</u>: JSON </p> <p> <u>Hosting</u>: HTTPS </p> <p> <u>Firewall</u>: Die Firewall auf dem Server sollte wenn möglich auf eine IP eingeschränkt werden können</p> <p><u>Authentifizierung</u>: Sämtliche Methoden sind mittels HTTP Basic Authentication geschützt. Bei jedem Serviceaufruf müssen Username und Passwort im RequestHeader mitgegeben werden. (Authorization: Basic).  </p> <hr>
 *
 * OpenAPI spec version: 1.0
 * Contact: myapostroph@apostrophgroup.ch
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Drupal\tmgmt_apostrophgroup_provider\Restclient;

use \Exception;

/**
 * ApiException Class Doc Comment
 *
 * @category Class
 * @package  Drupal\tmgmt_apostrophgroup_provider\Restclient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class HeaderSelector
{

    /**
     * @param string[] $accept
     * @param string[] $contentTypes
     * @return array
     */
    public function selectHeaders($accept, $contentTypes)
    {
        $headers = [];

        $accept = $this->selectAcceptHeader($accept);
        if ($accept !== null) {
            $headers['Accept'] = $accept;
        }

        $headers['Content-Type'] = $this->selectContentTypeHeader($contentTypes);
        return $headers;
    }

    /**
     * @param string[] $accept
     * @return array
     */
    public function selectHeadersForMultipart($accept)
    {
        $headers = $this->selectHeaders($accept, []);

        unset($headers['Content-Type']);
        return $headers;
    }

    /**
     * Return the header 'Accept' based on an array of Accept provided
     *
     * @param string[] $accept Array of header
     *
     * @return string Accept (e.g. application/json)
     */
    private function selectAcceptHeader($accept)
    {
        if (count($accept) === 0 || (count($accept) === 1 && $accept[0] === '')) {
            return null;
        } elseif (preg_grep("/application\/json/i", $accept)) {
            return 'application/json';
        } else {
            return implode(',', $accept);
        }
    }

    /**
     * Return the content type based on an array of content-type provided
     *
     * @param string[] $contentType Array fo content-type
     *
     * @return string Content-Type (e.g. application/json)
     */
    private function selectContentTypeHeader($contentType)
    {
        if (count($contentType) === 0 || (count($contentType) === 1 && $contentType[0] === '')) {
            return 'application/json';
        } elseif (preg_grep("/application\/json/i", $contentType)) {
            return 'application/json';
        } else {
            return implode(',', $contentType);
        }
    }
}

