<?php
/**
 * TranslationData
 *
 * PHP version 5
 *
 * @category Class
 * @package  Drupal\tmgmt_apostrophgroup_provider\Restclient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Apostroph Group Rest API
 *
 * <h2>Einleitung </h2> <p>Das folgende Dokument beschreibt die REST Service Schnittstelle für myApostroph und einem externen Partner oder Kunden. Nachfolgend werden allgemeine Informationen zur Service beschrieben und dann die konkrete technische Implementierung.</p> <hr> <h2> Allgemeines </h2> <p>Dieser Service dient dazu, dass ein externer Partner oder Kunde von Apostroph Aufträge direkt via „Internet“ im ERP System Apos erstellen und bei Fertigstellung des Auftrages diesen auch abholen kann. Die Realisierung ist mittels ein REST Services realisiert. </p> <hr> <h2> Wissenswertes </h2>  <li> In der aktuellen Version kann nur eine Übersetzung erstellt werden. Bspw. von „de“ nach „en“, aber nicht von „de“ nach „en“ und von „de“ nach „fr“.</li> <li>Zusätzlich zu den Auftragsinformationen können 2 Dateien übermittelt werden.  <ul><li>Datei mit Endung xliff (kann erweitert werden)</li> <li>Datei mit Endung tmx</li></ul> Beide Dateien müssen im Zip Format übertragen/geliefert werden</li> <li>Die Initialisierung des Services passiert immer von Seite „externer Partner“. Dieser Service des Partners liefert Daten und holt auch wieder Daten ab</li> <li>Pro Auftrag muss immer eine Apos Kundennummer mitgegeben werden, so kann der Auftrag dem korrekten Kunden zugeordnet werden. Diese Nummern müssen auf Seite externer Partner bekannt sein </li> <hr> <h2> Service Beschreibung </h2> <p><u>Servicetyp</u>: REST</p> <p> <u>Serialisierung</u>: JSON </p> <p> <u>Hosting</u>: HTTPS </p> <p> <u>Firewall</u>: Die Firewall auf dem Server sollte wenn möglich auf eine IP eingeschränkt werden können</p> <p><u>Authentifizierung</u>: Sämtliche Methoden sind mittels HTTP Basic Authentication geschützt. Bei jedem Serviceaufruf müssen Username und Passwort im RequestHeader mitgegeben werden. (Authorization: Basic).  </p> <hr>
 *
 * OpenAPI spec version: 1.0
 * Contact: myapostroph@apostrophgroup.ch
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Drupal\tmgmt_apostrophgroup_provider\Restclient\Model;

use \ArrayAccess;
use \Drupal\tmgmt_apostrophgroup_provider\Restclient\ObjectSerializer;

/**
 * TranslationData Class Doc Comment
 *
 * @category Class
 * @package  Drupal\tmgmt_apostrophgroup_provider\Restclient
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class TranslationData implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'translationData';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'desired_deadline' => 'string',
'comment' => 'string',
'is_revision' => 'bool',
'source_language' => 'string',
'target_language' => 'string',
'project_title' => 'string',
'is_confidential' => 'bool',
'customer_id' => 'int',
'source_document_content' => 'string',
'metadata_document_content' => 'string',
'reference_translation_id' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'desired_deadline' => null,
'comment' => null,
'is_revision' => null,
'source_language' => null,
'target_language' => null,
'project_title' => null,
'is_confidential' => null,
'customer_id' => 'int32',
'source_document_content' => 'base64',
'metadata_document_content' => 'base64',
'reference_translation_id' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'desired_deadline' => 'DesiredDeadline',
'comment' => 'Comment',
'is_revision' => 'IsRevision',
'source_language' => 'SourceLanguage',
'target_language' => 'TargetLanguage',
'project_title' => 'ProjectTitle',
'is_confidential' => 'IsConfidential',
'customer_id' => 'CustomerId',
'source_document_content' => 'SourceDocumentContent',
'metadata_document_content' => 'MetadataDocumentContent',
'reference_translation_id' => 'ReferenceTranslationId'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'desired_deadline' => 'setDesiredDeadline',
'comment' => 'setComment',
'is_revision' => 'setIsRevision',
'source_language' => 'setSourceLanguage',
'target_language' => 'setTargetLanguage',
'project_title' => 'setProjectTitle',
'is_confidential' => 'setIsConfidential',
'customer_id' => 'setCustomerId',
'source_document_content' => 'setSourceDocumentContent',
'metadata_document_content' => 'setMetadataDocumentContent',
'reference_translation_id' => 'setReferenceTranslationId'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'desired_deadline' => 'getDesiredDeadline',
'comment' => 'getComment',
'is_revision' => 'getIsRevision',
'source_language' => 'getSourceLanguage',
'target_language' => 'getTargetLanguage',
'project_title' => 'getProjectTitle',
'is_confidential' => 'getIsConfidential',
'customer_id' => 'getCustomerId',
'source_document_content' => 'getSourceDocumentContent',
'metadata_document_content' => 'getMetadataDocumentContent',
'reference_translation_id' => 'getReferenceTranslationId'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['desired_deadline'] = isset($data['desired_deadline']) ? $data['desired_deadline'] : null;
        $this->container['comment'] = isset($data['comment']) ? $data['comment'] : null;
        $this->container['is_revision'] = isset($data['is_revision']) ? $data['is_revision'] : null;
        $this->container['source_language'] = isset($data['source_language']) ? $data['source_language'] : null;
        $this->container['target_language'] = isset($data['target_language']) ? $data['target_language'] : null;
        $this->container['project_title'] = isset($data['project_title']) ? $data['project_title'] : null;
        $this->container['is_confidential'] = isset($data['is_confidential']) ? $data['is_confidential'] : null;
        $this->container['customer_id'] = isset($data['customer_id']) ? $data['customer_id'] : null;
        $this->container['source_document_content'] = isset($data['source_document_content']) ? $data['source_document_content'] : null;
        $this->container['metadata_document_content'] = isset($data['metadata_document_content']) ? $data['metadata_document_content'] : null;
        $this->container['reference_translation_id'] = isset($data['reference_translation_id']) ? $data['reference_translation_id'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['desired_deadline'] === null) {
            $invalidProperties[] = "'desired_deadline' can't be null";
        }
        if ($this->container['is_revision'] === null) {
            $invalidProperties[] = "'is_revision' can't be null";
        }
        if ($this->container['source_language'] === null) {
            $invalidProperties[] = "'source_language' can't be null";
        }
        if ($this->container['target_language'] === null) {
            $invalidProperties[] = "'target_language' can't be null";
        }
        if ($this->container['project_title'] === null) {
            $invalidProperties[] = "'project_title' can't be null";
        }
        if ($this->container['customer_id'] === null) {
            $invalidProperties[] = "'customer_id' can't be null";
        }
        if ($this->container['source_document_content'] === null) {
            $invalidProperties[] = "'source_document_content' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets desired_deadline
     *
     * @return string
     */
    public function getDesiredDeadline()
    {
        return $this->container['desired_deadline'];
    }

    /**
     * Sets desired_deadline
     *
     * @param string $desired_deadline Datum
     *
     * @return $this
     */
    public function setDesiredDeadline($desired_deadline)
    {
        $this->container['desired_deadline'] = $desired_deadline;

        return $this;
    }

    /**
     * Gets comment
     *
     * @return string
     */
    public function getComment()
    {
        return $this->container['comment'];
    }

    /**
     * Sets comment
     *
     * @param string $comment Bemerkungen
     *
     * @return $this
     */
    public function setComment($comment)
    {
        $this->container['comment'] = $comment;

        return $this;
    }

    /**
     * Gets is_revision
     *
     * @return bool
     */
    public function getIsRevision()
    {
        return $this->container['is_revision'];
    }

    /**
     * Sets is_revision
     *
     * @param bool $is_revision Ist es eine Nachübersetzung (wenn ja: tmx file muss mitgeliefert werden)
     *
     * @return $this
     */
    public function setIsRevision($is_revision)
    {
        $this->container['is_revision'] = $is_revision;

        return $this;
    }

    /**
     * Gets source_language
     *
     * @return string
     */
    public function getSourceLanguage()
    {
        return $this->container['source_language'];
    }

    /**
     * Sets source_language
     *
     * @param string $source_language 2 Stellig
     *
     * @return $this
     */
    public function setSourceLanguage($source_language)
    {
        $this->container['source_language'] = $source_language;

        return $this;
    }

    /**
     * Gets target_language
     *
     * @return string
     */
    public function getTargetLanguage()
    {
        return $this->container['target_language'];
    }

    /**
     * Sets target_language
     *
     * @param string $target_language 2 Stellig
     *
     * @return $this
     */
    public function setTargetLanguage($target_language)
    {
        $this->container['target_language'] = $target_language;

        return $this;
    }

    /**
     * Gets project_title
     *
     * @return string
     */
    public function getProjectTitle()
    {
        return $this->container['project_title'];
    }

    /**
     * Sets project_title
     *
     * @param string $project_title 50 Zeichen
     *
     * @return $this
     */
    public function setProjectTitle($project_title)
    {
        $this->container['project_title'] = $project_title;

        return $this;
    }

    /**
     * Gets is_confidential
     *
     * @return bool
     */
    public function getIsConfidential()
    {
        return $this->container['is_confidential'];
    }

    /**
     * Sets is_confidential
     *
     * @param bool $is_confidential Kein Mussfeld
     *
     * @return $this
     */
    public function setIsConfidential($is_confidential)
    {
        $this->container['is_confidential'] = $is_confidential;

        return $this;
    }

    /**
     * Gets customer_id
     *
     * @return int
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param int $customer_id KundenNr Apos
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets source_document_content
     *
     * @return string
     */
    public function getSourceDocumentContent()
    {
        return $this->container['source_document_content'];
    }

    /**
     * Sets source_document_content
     *
     * @param string $source_document_content xliff file zipped (base64 encoded)
     *
     * @return $this
     */
    public function setSourceDocumentContent($source_document_content)
    {
        $this->container['source_document_content'] = $source_document_content;

        return $this;
    }

    /**
     * Gets metadata_document_content
     *
     * @return string
     */
    public function getMetadataDocumentContent()
    {
        return $this->container['metadata_document_content'];
    }

    /**
     * Sets metadata_document_content
     *
     * @param string $metadata_document_content tmx file zipped (base64 encoded)
     *
     * @return $this
     */
    public function setMetadataDocumentContent($metadata_document_content)
    {
        $this->container['metadata_document_content'] = $metadata_document_content;

        return $this;
    }

    /**
     * Gets reference_translation_id
     *
     * @return string
     */
    public function getReferenceTranslationId()
    {
        return $this->container['reference_translation_id'];
    }

    /**
     * Sets reference_translation_id
     *
     * @param string $reference_translation_id TranslationId der Erstübersetzung (Muss bei einer Nachübersetzung mitgeliefert werden, muss sonst leer sein)
     *
     * @return $this
     */
    public function setReferenceTranslationId($reference_translation_id)
    {
        $this->container['reference_translation_id'] = $reference_translation_id;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
